﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Problem.BenchmarkSuite {
  using Common;
  using Configuration;
  using Core;

  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;

  using Persistence.Default.CompositeSerializers.Storable;

  [StorableClass]
  public class PushBenchmarkSuiteSolution : PushSolution {
    public PushBenchmarkSuiteSolution(
      PushProgram program,
      double quality,
      IRandom random,
      IReadOnlyPushConfiguration config,
      PushBenchmarkSuiteEvaluator evaluator,
      bool simplify = false) : base(program, quality, random, config, evaluator, simplify) {
    }

    public PushBenchmarkSuiteSolution(PushBenchmarkSuiteSolution origin, Cloner cloner) : base(origin, cloner) { }

    [StorableConstructor]
    public PushBenchmarkSuiteSolution(bool deserializing) : base(deserializing) { }

    public override PushSolution Simplify() {
      return new PushBenchmarkSuiteSolution(Program, Quality, Random, Config, (PushBenchmarkSuiteEvaluator)Evaluator, true);
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new PushBenchmarkSuiteSolution(this, cloner);
    }
  }
}
